''
'' cog to hub transfer
''
''        Author: Marko Lukat (kuroneko)
'' Last modified: 2011/02/18
''       Version: 0.1
''
'' acknowledgements
'' - code based on work done by Phil Pilgrim (PhiPi) and Ray Rodrick (Cluso99)
''
CON
  _clkmode = XTAL1|PLL16X
  _xinfreq = 5_000_000

OBJ
  term : "FullDuplexSerial"

VAR
  long  guard_before, storage[128], guard_after

PUB null | n

  term.start( 31, 30, 0, 115200 )

  cognew(@entry, @storage{0})
  waitcnt(clkfreq + cnt)

  term.str( string( 13, "Starting the test...", 13 ) )

  if guard_before or guard_after
    term.str( string( "FAILED", 13 ) )
  else
    repeat n from 0 to 127
      if storage[n] <> $DEADBEEF
        term.str( string( "FAILED", 13 ) )
        quit

  term.str( string( "Done with " ) )
  term.dec( n )
  term.str( string( " samples.", 13 ) )

  waitpne(0, 0, 0)

DAT             org     0

entry           movd    xfer_copy7, #data + 127  '  -4   move cog address into wrlong instruction
                movd    xfer_copy1, #data + 126  '  +0   move cog address into wrlong instruction

                movi    ctra, #%0_11111_000     '  +4   LOGIC always

                'long    0[12] {3 x nop}          '  +8   adjustment (phsa setup is critical)

                mov     frqa, par               '  +4   frqa gets added twice between modifying
                shr     frqa, #1                '  +8   shadow[phsa] and wrlong
                mov     phsa, #512 - 1          '  -4   hub byte count (8n + 7)

xfer_copy7      wrlong  0-0, phsa               '  +0 = copy long from cog to hub
                sub     $-1, dst2               '  +8   decrement cog address by 2
                sub     phsa, #7 wz             '  -4   decrement hub length by 1 long (prev by 1, now by 7)

xfer_copy1      wrlong  0-0, phsa               '  +0 = copy long from cog to hub
                sub     $-1, dst2               '  +8   decrement cog address by 2
        if_nz   djnz    phsa, #xfer_copy7       '  -4   decrement hub length by 1 long (prev by 7, now by 1)

                cogid   cnt                     '
                cogstop cnt                     ' sayonara ...

' initialised data and/or presets

dst2            long    2 << 9
data            long    $DEADBEEF[128]

' uninitialised data and/or temporaries

                fit
