CON
        _clkmode        = sysdep#_clkmode
        _xinfreq        = sysdep#_xinfreq
        MB = 1
        block_count = MB * 2048 ' 2048 * 512 bytes = 1 MB
        block_start = 4 * 2048   ' start near the 4MB range
obj
   sysdep: "sysdep"
   sdspi: "mb_spi"
var
   long ref_buf[512>>2]
   long in_buf[512>>2]
pub go | x
   x := \doloop
   sysdep.str(string(13, "Returned from start: "))
   sysdep.dec(x)
pub doloop
   sysdep.start
   repeat
      start   
pub start | r, sta, bytes, ar, valid
  sysdep.rx
  sysdep.str(string("Mounting: "))        
  sysdep.dec( sdspi.start(sysdep#sd_base) )
  r := cnt
  repeat bytes from 0 to 127
    ref_buf[bytes] := ?r

  ' needed for the Kodak card!
  ar := \sdspi.readblock( 0, @in_buf )
   
  sysdep.str(string( 13, "Starting trials with "))
  sysdep.dec( MB )
  sysdep.str( string( "MB", 13 ) ) 
   
  sta := cnt
  repeat r from block_start to constant(block_start + block_count - 1)
    ar := \sdspi.writeblock( r, @ref_buf )
    if ar <> 0
      sysdep.str(string("WE@"))
      sysdep.dec( r )
      sysdep.tx( ":" )
      sysdep.dec( ar )
      sysdep.tx( "," )      
  r := (cnt - sta)
  sysdep.str(string("Writing took "))
  sysdep.dec( r / (clkfreq/1000) ) 
  sysdep.str( string( "[ms]", 13 ) )
   
  sta := cnt
  repeat r from block_start to constant(block_start + block_count - 1)
    ar := \sdspi.readblock( r, @in_buf )
    if ar <> 0
      sysdep.str(string("RE@"))
      sysdep.dec( r )
      sysdep.tx( ":" )
      sysdep.dec( ar )
      sysdep.tx( "," )
  r := (cnt - sta)
  sysdep.str(string("Reading took "))
  sysdep.dec( r / (clkfreq/1000) )
  sysdep.str( string( "[ms]", 13 ) )

  'sdspi.flush
   
  sysdep.str(string("Validating (slow): "))
  valid := true
  sta := sdspi.get_seconds
  repeat r from block_start to constant(block_start + block_count - 1)
    ' gen the 'random' block with the address as its seed
    ar := r
    repeat bytes from 0 to 127
      ref_buf[bytes] := ?ar
    ar := \sdspi.writeblock( r, @ref_buf )
    if ar <> 0
      sysdep.str(string("WE@"))
      sysdep.dec( r )
      sysdep.tx( ":" )
      sysdep.dec( ar )
      sysdep.tx( "," )

  repeat r from block_start to constant(block_start + block_count - 1)
    ' re-gen the 'random' block with the address as its seed
    ar := r
    repeat bytes from 0 to 127
      ref_buf[bytes] := ?ar
    ar := \sdspi.readblock( r, @in_buf )
    if ar <> 0
      sysdep.str(string("RE@"))
      sysdep.dec( r )
      sysdep.tx( ":" )
      sysdep.dec( ar )
      sysdep.tx( "," )
    repeat bytes from 0 to 127
      valid AND= (ref_buf[bytes] == in_buf[bytes])

  r := (sdspi.get_seconds - sta)
                             
  if valid
    sysdep.str( string( "good" ) )
  else
    sysdep.str( string( "bad" ) )

  sysdep.str(string(13,"Validation took "))
  sysdep.dec( r )
  sysdep.str( string( "[s]" ) )

{{
'  Permission is hereby granted, free of charge, to any person obtaining
'  a copy of this software and associated documentation files
'  (the "Software"), to deal in the Software without restriction,
'  including without limitation the rights to use, copy, modify, merge,
'  publish, distribute, sublicense, and/or sell copies of the Software,
'  and to permit persons to whom the Software is furnished to do so,
'  subject to the following conditions:
'
'  The above copyright notice and this permission notice shall be included
'  in all copies or substantial portions of the Software.
'
'  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
'  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
'  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
'  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
'  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
'  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
}}