CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000
   offset = 8 * 2048 ' the block offset of where we do writes
   serXmit   = 30                      ' Serial Transmit
   serRecv   = 31                      ' Serial Receive
   speed     = 9600
   sd_DO = 0
   sd_CLK = 1
   sd_DI = 2
   sd_CS = 3
obj
'   term: "sysdep"
   sdfat[2]: "fsrw_sidx2"'
   debug:   "MultiCogSerialDebug" 'debugport serial driver

var
   byte bigbuf1[512]
   byte bigbuf2[512]
   byte debugSemID
   byte fileSemID
   long stack1[64]
   long stack2[64]

pub main | retval, cog1Done, cog2Done,cogTstId
  waitcnt(cnt + clkfreq*2)

  debugSemID := locknew
  fileSemID  := locknew

  debug.start(serRecv,serXmit,0,speed,debugSemID)
  debug.cprintf(string("start of main program x2\r"), 0, true)
  debug.cprintf(string("debugSemID %d \r"), debugSemID, true)
  debug.cprintf(string("fileSemID %d \r"), fileSemID, false)

  retval := \sdfat.mount_explicit(sd_DO, sd_CLK, sd_DI, sd_CS)
  debug.cprintf(string("after mount %d \r"), retval, false)

  cog1done := false
  cog2done := false

  cogTstId := cognew(fsTstCog1(string("OB1.SRP"), 0, @bigBuf1, @cog1done), @Stack1)
  cogTstId := cognew(fsTstCog1(string("JH5.DAT"), 1, @bigBuf2, @cog2done), @Stack2)

  repeat while (cog1done == FALSE) OR (cog2done == FALSE)

  debug.cprintf(string("finished %d \r"), retval, false)
  repeat

PUB fsTstCog1(filename, fsidx, bufptr, cog1donePtr) | retval, idx

  repeat until not lockset(fileSemID)
  retval := \sdfat[fsidx].popen(filename,"r")
'  retval := \sdfat[fsidx].popen(string("OB1.SRP"),"r")
'  retval := \sdfat.popen(string("JH5.DAT"),"r")
  lockclr(fileSemID)

  debug.cprintf(string("after open %d \r"), retval, false)

  bytefill(bufptr, 0, 512)

  repeat
     repeat until not lockset(fileSemID)
     retval := \sdfat[fsidx].pread(bufptr, 512)
     lockclr(fileSemID)

     debug.cprintf(string("read %d bytes\r"), retval, false)
     if (retval > 0)
       repeat idx from 0 to retval
          if (byte[bufptr + idx] > $20)
             debug.cprintf(string("%c"), byte[bufptr + idx], true)
          else
             debug.cprintf(string("."), 0, true)
       debug.cprintf(string("\r"), 0, false)
     else
        quit

  debug.cprintf(string("\r"), 0, false)

  repeat until not lockset(fileSemID)
  retval := \sdfat[fsidx].pclose
  lockclr(fileSemID)

  debug.cprintf(string("pclose %d \r"), retval, false)

  long[cog1donePtr] := TRUE

